// Conting sort
#include <iostream>


// The main function that sorts the given string arr[] in
// alphabatical order
void countSort(char arr[], int n, int RANGE)
{
    // The output character array that will have sorted arr
    char output[n];

    // Create a count array to store count of inidividul
    // characters and initialize count array as 0
    // Note: this all-0s syntax only works with {0}
    int count[RANGE + 1]{0};
    int i;

    // Store count of each character
    // Ask: How is arr[i] interpreted here?
    for(i = 0; arr[i]; ++i)
        ++count[arr[i]];

    // Change count[i] so that count[i] now contains actual
    // position of this character in output array
    // Prefix sum
    for(i = 1; i <= RANGE; ++i)
        count[i] += count[i - 1];

    // Build the output character array
    for(i = 0; arr[i]; ++i)
    {
        output[count[arr[i]] - 1] = arr[i];
        --count[arr[i]];
    }

    // Copy the output array to arr, so that arr now
    // contains sorted characters
    for(i = 0; arr[i]; ++i)
        arr[i] = output[i];
}

// Driver program to test above function
int main()
{
    const int RANGE =  255;
    char arr[] = "hello";
    int n = 5;

    countSort(arr, n, RANGE);

    std::cout << "Sorted character array is " << arr << "\n";

    return 0;
}

